function love.load()
--size of the squares

size = 32

xMouse, yMouse = love.mouse.getPosition( )
--center the boardgame in the window
caseX=love.graphics.getWidth()/2-size*5
caseY=love.graphics.getHeight()/2-size*5
--position of the score
scoreX=love.graphics.getWidth()/2+size*5+10
scoreY=caseY
score=0
--position of the player
posX = 32.0
posY = 0.0
--speed of the player
speed = 64
--scale width of the player for make a mirror of the sprite
scaleX=1
--player table

--Selected case by the mouse
selectedCaseX=-1
selectedCaseY=-1
--FirstSelected Case
fstSelectionX=-1
fstSelectionY=-1
--Destination Case
scdSelectionX=-1
scdSelectionY=-1

Tableboard={}
for y=0,9 do
	Tableboard[y]={}
	for x=0,9 do
		if(y%2==0 and x%2==0)then
			--5 = cases clair injouables
			Tableboard[y][x]=5
		elseif(y%2==1 and x%2==1)then
			Tableboard[y][x]=5
		elseif(y%2==0 and x%2==1)then
			if(y<4)then
				Tableboard[y][x]=1
			elseif(y==4)then
				Tableboard[y][x]=0
			elseif(y>5)then
				Tableboard[y][x]=3
			end
		elseif(y%2==1 and x%2==0)then
			if(y<4)then
				Tableboard[y][x]=1
			elseif(y==5)then
				Tableboard[y][x]=0
			elseif(y>5)then
				Tableboard[y][x]=3
			end
		end
	end
end
--Wood Zones jouables = 5
Tableboard.wood=love.graphics.newImage("assets/wood.png")
--Pion blanc = 1
Tableboard.pionB=love.graphics.newImage("assets/pionb.png")
Tableboard.dameB=love.graphics.newImage("assets/dameb.png")
--Pion noir = 3
Tableboard.pionN=love.graphics.newImage("assets/pionn.png")
Tableboard.dameN=love.graphics.newImage("assets/damen.png")
--Clear Zones non jouables = 5
Tableboard.clear=love.graphics.newImage("assets/clear.png")

player={}
-- bool = 0 : Joueur blanc -- bool = 1 :Joueur noir
player.bool=0
--picture of the player

player.img = love.graphics.newImage("assets/dameb.png")
--position of the background
posXbg=love.graphics.getWidth()/2-320
posYbg=love.graphics.getHeight()/2-240
--background picture
bg = love.graphics.newImage("assets/background.png")
posOrX=32
end
function love.draw()
	love.graphics.draw(bg, posXbg,posYbg)
	for y=0,9 do
		for x=0, 9 do
			if(Tableboard[y][x]==5)then
				--love.graphics.rectangle("fill",caseX+size*x,caseY+size*y,size,size)
				love.graphics.draw(Tableboard.clear,caseX+size*x,caseY+size*y)
			elseif(Tableboard[y][x]==1)then
				love.graphics.draw(Tableboard.wood,caseX+size*x,caseY+size*y)
				love.graphics.draw(Tableboard.pionB,caseX+size*x,caseY+size*y)
			elseif(Tableboard[y][x]==3)then
				love.graphics.draw(Tableboard.wood,caseX+size*x,caseY+size*y)
				love.graphics.draw(Tableboard.pionN,caseX+size*x,caseY+size*y)
			elseif(Tableboard[y][x]==0)then
				love.graphics.draw(Tableboard.wood,caseX+size*x,caseY+size*y)	
			end
			if (selectedCaseX>-1 and selectedCaseY>-1)then
				love.graphics.rectangle("line",caseX+size*selectedCaseX,caseY+size*selectedCaseY,size,size)		
			end
			if(fstSelectionX>-1 and fstSelectionY>-1)then
				love.graphics.setColor(0,0.8,1,1)
				love.graphics.rectangle("line",caseX+size*fstSelectionX,caseY+size*fstSelectionY,size,size)
				love.graphics.setColor(1,1,1)
			end
			if(scdSelectionX>-1 and scdSelectionY>-1)then
				love.graphics.setColor(0.8,0,1,1)
				love.graphics.rectangle("line",caseX+size*scdSelectionX,caseY+size*scdSelectionY,size,size)
				love.graphics.setColor(1,1,1)
			end
		end
	end
	love.graphics.rectangle("line",caseX,caseY,size*10,size*10)
	love.graphics.draw(player.img, posX,posY,0, scaleX,1,posOrX,0)
	love.graphics.setColor(0,0,0 )
	love.graphics.print("Position X Player :"..math.floor(posX),scoreX,scoreY)
	love.graphics.print("Position X Mouse:"..xMouse,scoreX,scoreY+10)
	love.graphics.print("Position Y Mouse:"..yMouse,scoreX,scoreY+20)
	love.graphics.print("Selection X: "..selectedCaseX.."Y: "..selectedCaseY,scoreX,scoreY+30)
	love.graphics.print("Score: "..score,scoreX,scoreY+50)
	if(fstSelectionX>-1 and fstSelectionY>-1)then
	love.graphics.print("Type: "..Tableboard[fstSelectionY][fstSelectionX],scoreX,scoreY+40)
	
	end
	love.graphics.setColor(1,1,1 )
end

function love.update(dt)
	check_input(dt)
	
	xMouse, yMouse = love.mouse.getPosition()
	caseX=love.graphics.getWidth()/2-size*5
	caseY=love.graphics.getHeight()/2-size*5
	scoreX=love.graphics.getWidth()/2+size*5+10	
	
	scoreY=caseY
	posXbg=love.graphics.getWidth()/2-320
	posYbg=love.graphics.getHeight()/2-240
	if(xMouse>caseX and yMouse>caseY and xMouse<caseX+size*10 and yMouse<caseY+size*10)then
		selectedCaseX=math.floor((xMouse-caseX)/32)
		selectedCaseY=math.floor((yMouse-caseY)/32)
		if(love.mouse.isDown(1))then
			--Pour le joueur blanc
			if(player.bool==0 and (Tableboard[selectedCaseY][selectedCaseX]==1 or Tableboard[selectedCaseY][selectedCaseX]==2))then
				fstSelectionX=selectedCaseX
				fstSelectionY=selectedCaseY
				scdSelectionX=-1
				scdSelectionY=-1
			--Pour le joueur noir
			elseif(player.bool==1 and (Tableboard[selectedCaseY][selectedCaseX]==3 or Tableboard[selectedCaseY][selectedCaseX]==4))then
				fstSelectionX=selectedCaseX
				fstSelectionY=selectedCaseY
				scdSelectionX=-1
				scdSelectionY=-1
			end
			--On établi la selection de destination
			if(fstSelectionX>-1 and fstSelectionY>-1)then
				--On teste la pièce en main
				if (player.bool==0 and Tableboard[fstSelectionY][fstSelectionX]==1)then
					--coup standard
					if(Tableboard[selectedCaseY][selectedCaseX]==0 and ((fstSelectionX-selectedCaseX==1 or selectedCaseX-fstSelectionX==1) and selectedCaseY-fstSelectionY==1 ))then			
						scdSelectionX=selectedCaseX
						scdSelectionY=selectedCaseY	
						if(scdSelectionX>-1 and scdSelectionY>-1)then
							Tableboard[fstSelectionY][fstSelectionX]=0
							Tableboard[scdSelectionY][scdSelectionX]=1
							scdSelectionY=-1
							scdSelectionX=-1
							fstSelectionX=-1
							fstSelectionY=-1
							player.bool=1
						end
					--Vérification de la destination : Possible ou non (pour une prise)
					elseif(Tableboard[selectedCaseY][selectedCaseX]==0)then
						--On déchiffre la direction choisie du joueur
						if(fstSelectionX>selectedCaseX)then
						--on sait ici que la direction est vers à gauche
							if(fstSelectionY<selectedCaseY)then
							--ici qu'on va vers le S.O.
								if(Tableboard[fstSelectionY+1][fstSelectionX-1]==3 or Tableboard[fstSelectionY+1][fstSelectionX-1]==4 and fstSelectionX-selectedCaseX==2 and selectedCaseY-fstSelectionY==2)then
									scdSelectionX=selectedCaseX
									scdSelectionY=selectedCaseY
									Tableboard[fstSelectionY+1][fstSelectionX-1]=0
									score=score+1
									Tableboard[fstSelectionY][fstSelectionX]=0
									Tableboard[scdSelectionY][scdSelectionX]=1
									detect_match(scdSelectionX,scdSelectionY)
									scdSelectionY=-1
									scdSelectionX=-1
									fstSelectionX=-1
									fstSelectionY=-1
								end
							elseif(fstSelectionY>selectedCaseY)then
							--ici on va vers le N-O
								if(Tableboard[fstSelectionY-1][fstSelectionX-1]==3 or Tableboard[fstSelectionY-1][fstSelectionX-1]==4 and fstSelectionX-selectedCaseX==2 and fstSelectionY-selectedCaseY==2)then
									scdSelectionX=selectedCaseX
									scdSelectionY=selectedCaseY
									Tableboard[fstSelectionY-1][fstSelectionX-1]=0
									score=score+1
									Tableboard[fstSelectionY][fstSelectionX]=0
									Tableboard[scdSelectionY][scdSelectionX]=1
									detect_match(scdSelectionX,scdSelectionY)
									scdSelectionY=-1
									scdSelectionX=-1
									fstSelectionX=-1
									fstSelectionY=-1
									
								end
							end
						elseif(fstSelectionX>selectedCaseX)then
							--Vers la droite
						end
					end
				--coup standard du joueur noir on test la pièce en main.
				elseif(player.bool==1 and Tableboard[fstSelectionY][fstSelectionX]==3)then
					if(Tableboard[selectedCaseY][selectedCaseX]==0 and ((fstSelectionX-selectedCaseX==1 or selectedCaseX-fstSelectionX==1) and fstSelectionY-selectedCaseY==1 ))then			
						scdSelectionX=selectedCaseX
						scdSelectionY=selectedCaseY	
						if(scdSelectionX>-1 and scdSelectionY>-1)then
							Tableboard[fstSelectionY][fstSelectionX]=0
							Tableboard[scdSelectionY][scdSelectionX]=3
							scdSelectionY=-1
							scdSelectionX=-1
							fstSelectionX=-1
							fstSelectionY=-1
							player.bool=0
						end
					end
				end
			end
		end
	else
		selectedCaseX=-1
		selectedCaseY=-1
	end
end

function check_input(dt)

	if love.keyboard.isDown("right") then
		if(math.floor(dt)%2==0)then
			posX = posX+32
			scaleX=1
			posOrX=32
		end
	elseif love.keyboard.isDown("left")then
		posX = posX-32
		scaleX=-1
		posOrX=0
	end

end

function detect_match(x,y)
	--Algorithme qui detect les prises possibles pour les blancs.
	if(Tableboard[y-2][x-2]==0 and (Tableboard[y-1][x-1]==3 or Tableboard[y-1][x-1]==4))then
		player.bool=0
	elseif(Tableboard[y+2][x-2]==0 and (Tableboard[y+1][x-1]==3 or Tableboard[y+1][x-1]==4))then
		player.bool=0
	elseif(Tableboard[y-2][x+2]==0 and (Tableboard[y-1][x+1]==3 or Tableboard[y-1][x+1]==4))then
		player.bool=0
	elseif(Tableboard[y+2][x+2]==0 and (Tableboard[y+1][x+1]==3 or Tableboard[y+1][x+1]==3))then
		player.bool=0
	else
		player.bool=1
	end
end